<template>
  <div>
    <el-form label-position="top" class="filter-form" size="large">
      <el-row :gutter="40">
        <el-col :xs="24" :sm="24" :lg="7">
          <el-form-item label="Lokasi Projek">
            <el-select
              v-model="params.city"
              multiple
              filterable
              remote
              clearable
              reserve-keyword
              class="ritx-autocomplete"
              placeholder="Tulis Lokasi"
              :remote-method="searchLocation"
              :loading="loading_location"
            >
              <el-option
                v-for="item in options_location"
                :key="item.value"
                :label="item.label"
                class="ritx-autocomplete-dropdown"
                :value="item.value"
              >
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :xs="24" :sm="24" :lg="7">
          <el-form-item label="Tanggal">
            <el-date-picker class="from" size="small" v-model="params.dateStart" align="left" type="date" placeholder="Dari"> </el-date-picker>
            <el-date-picker class="to" size="small" v-model="params.dateEnd" align="right" type="date" placeholder="Sampai"> </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :xs="24" :sm="24" :lg="3">
          <el-form-item>
            <el-button type="ritx-primary" v-on:click="submit">Simpan</el-button>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
  </div>
</template>
<script>
import { getCities } from '@/api/city';
import { getCommodities } from '@/api/commodity';
export default {
  name: 'FilterComponent',
  data() {
    return {
      params: {
        gender: '',
        status: '',
        apps: [],
        city: [],
        commodity: [],
        dateStart: '',
        dateEnd: ''
      },
      options_location: [],
      loading_location: false,
      options_commodity: [],
      loading_commodity: false
    };
  },
  methods: {
    searchLocation(query) {
      if (query !== '') {
        this.loading_location = true;
        setTimeout(() => {
          this.loading_location = false;
          getCities(query).then(response => {
            this.options_location = response.data.data.map(item => {
              return { value: item.id, label: item.city_name };
            });
          });
        }, 200);
      } else {
        this.options_location = [];
      }
    },
    searchComodity(query) {
      if (query !== '') {
        this.loading_commodity = true;
        setTimeout(() => {
          this.loading_commodity = false;
          getCommodities(query).then(response => {
            this.options_commodity = response.data.data.map(item => {
              return { value: item.id, label: item.plant_name };
            });
          });
        }, 200);
      } else {
        this.options_commodity = [];
      }
    },
    submit() {
      this.updateParams(this.params);
    },
    updateParams(params) {
      this.$emit('updateParams', params);
    }
  }
};
</script>
<style rel="stylesheet/scss" lang="scss" scoped>
@import '@/styles/variables.scss';
.filter-form {
  background: #f9fbf8;
  margin: 0 -30px 0 -30px;
  padding: 20px 30px 0 30px;
  .el-button {
    &--ritx-primary {
      margin-top: 38px;
    }
  }
}
.el-select-dropdown__item.selected {
  color: $ritx-greyish-brown;
}
.from{
  background-color: #e9f1e4;
  color: #4a4a4a;
  font-size: 14px;
  border: solid 1px #086939;
  border-radius: 4px;
  width: 150px;
  height: 40px;
  padding: 2px
}
.to{
  background-color: #e9f1e4;
  color: #4a4a4a;
  font-size: 14px;
  border: solid 1px #086939;
  border-radius: 4px;
  width: 150px;
  height: 40px;
  padding: 2px
}
</style>
